/* Copyright (c) 2002-2005, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licencing information, please refer to the
 * copyright file COPYRIGHT_MVAPICH in the top level MPICH directory.
 *
 */

#ifndef _VAPI_HEADER_H
#define _VAPI_HEADER_H


#undef IN
#undef OUT
#include<vapi.h>
#include<evapi.h>
#include<mtl_common.h>


#include <ib_defs.h>

#include <vapi_common.h>

#include "vapi_const.h"
#include "via64.h"

double get_us(void);

#define INVAL_HNDL (0xffffffff)


#define IN
#define OUT

#undef MALLOC
#undef FREE
/* src/env/initutil.c NEW not defined */
#define MALLOC(a)    malloc((unsigned)(a))
#define CALLOC(a,b)  calloc((unsigned)(a),(unsigned)(b))
#define FREE(a)      free((char *)(a))
#define NEW(a)    (a *)MALLOC(sizeof(a))
#define STRDUP(a) 	strdup(a)


/* memory handle */
typedef struct {
    VAPI_mr_hndl_t hndl;
    VAPI_lkey_t lkey;
    VAPI_rkey_t rkey;
} VIP_MEM_HANDLE;

typedef MT_virt_addr_t virt_addr_t;

#ifdef USE_INLINE
extern int inline_size;
#endif
#if 0
#define D_PRINT(fmt, args...)	{fprintf(stderr, "[%d][%s:%d]", viadev.me, __FILE__, __LINE__);\
				 fprintf(stderr, fmt, ## args); fflush(stderr);}
#else
#define D_PRINT(fmt, args...)
#endif
#endif
